#pragma once

#include "..\..\DuiLib\UIlib.h"

using namespace DuiLib;

class CSettingGeneral;
class CSettingPersonal;
class CSettingMessage;
class CSettingAutoText;

#define TAB_SETTING_GENERAL		0
#define TAB_SETTING_PERSONAL	1
#define TAB_SETTING_MESSAGE		2
#define TAB_SETTING_AUTOTEXT	3

#define PERSONAL_GROUP_EXPORT	0
#define PERSONAL_GROUP_IMPORT	1

#define MSG_CLOSE_SETTING_FRAME	(WM_USER + 9950)
#define MSG_RESTART_APP	(WM_USER + 9951)

class CSettingFrame : public WindowImplBase
{
    DUI_DECLARE_MESSAGE_MAP()
    DUI_DECLARE_CUSTOM_MSG_MAP()
public:
	CSettingFrame();
	~CSettingFrame();

	LPCTSTR GetWindowClassName() const;
	void InitWindow();
	void OnPrepare(TNotifyUI& msg);
	
	virtual CControlUI* CreateControl(LPCTSTR pstrClass);
	virtual CDuiString GetSkinFile();
	virtual CDuiString GetSkinFolder();
	virtual void OnFinalMessage(HWND hWnd);
	virtual LRESULT OnKillFocus(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnNcHitTest(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	void SetSelectButton(bool bSelect);
	//void SwitchFrameButton(bool bSwitch);
	void SetWindowPosition(CRect rcParent);
	void CloseSettingFrame();
	void FlashSettingFrame();
	void SaveAllConfig();
	void SetEnableFlash(BOOL bEnableFlash);

protected:
	//void Notify(TNotifyUI& msg);
	void NotifyCtrlClick(TNotifyUI& msg);
	void NotifyCtrlTime(TNotifyUI& msg);
	void NotifyTabSelectChange(TNotifyUI& msg);
	void NotifyTextChange(TNotifyUI& msg);
	void NotifyItemSelect(TNotifyUI& msg);
	void OnNotifyItemDoubleClick(TNotifyUI& msg);
    void OnNotifySetFocus(TNotifyUI& msg);
    void OnNotifyKillFocus(TNotifyUI& msg);

	void NotifyItemClick(TNotifyUI& msg);
// DUI member
private:

private:
	int					m_nFlashTimes;
	BOOL				m_bClosing;
	BOOL				m_bEnableFlash;
	int					m_nCurSelTab;
	CSettingPersonal*	m_pSettingPersonal;
	CSettingGeneral*	m_pSettingGeneral;
	CSettingMessage*	m_pSettingMessage;
	CSettingAutoText*	m_pSettingAutoText;
private:
    LRESULT _OnMsgKeyDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT _OnMsgWindowPosChanging(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
};
